unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, Grids, ValEdit, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    shLoptica: TShape;
    Timer1: TTimer;
    shArena: TShape;
    BitBtn1: TBitBtn;
    cbPoz: TColorBox;
    cbOkvirLoptice: TColorBox;
    cbUnutra: TColorBox;
    shLako: TShape;
    ShSrednje: TShape;
    shTesko: TShape;
    lblTezina: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edIme: TEdit;
    Label4: TLabel;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    Shape3: TShape;
    BitBtn5: TBitBtn;
    cbOkvirArene: TColorBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Shape1: TShape;
    lblPoeni: TLabel;
    Label8: TLabel;
    Shape2: TShape;
    lblVreme: TLabel;
    BitBtn6: TBitBtn;
    Timer2: TTimer;
    TabelaLako: TValueListEditor;
    TabelaSrednje: TValueListEditor;
    TabelaTesko: TValueListEditor;
    BitBtn7: TBitBtn;
    PopupMenu: TPopupMenu;
    Pokreni: TMenuItem;
    Restart1: TMenuItem;
    HighScore1: TMenuItem;
    Autor1: TMenuItem;
    Izlaz1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Miniprikaz: TMenuItem;
    Osvezi: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure shLopticaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenjajTezinu(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cbOkvirLopticeChange(Sender: TObject);
    procedure cbUnutraChange(Sender: TObject);
    procedure cbPozChange(Sender: TObject);
    procedure cbOkvirAreneChange(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure edImeChange(Sender: TObject);
    procedure edImeExit(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure shArenaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MiniprikazClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure OsveziClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
strTezina='Tezina igre: ';
strPauza='Zaustavi';
strNastavi='Nastavi';
strPokreni='Pokreni';
strNovaIgra='Nova igra';
duzinaIgre=30;
strUnknown='Nepoznati';

var
  Form1: TForm1;
  desno, dole, pokrenuto, pauza: boolean;
  skor, tezina, trenutnoVreme: integer;
  col, row, greska1, greska2, greska3: integer;
  TOPRezultatLako, TOPRezultatSrednje, TOPRezultatTesko: integer;
  imeIgraca: string;
  
implementation

uses Unit2, Unit3;

{$R *.dfm}




procedure Obrisi(ValueList: TValueListEditor);
begin
ValueList.Cells[0,1]:='...';
ValueList.Cells[0,2]:='...';
ValueList.Cells[0,3]:='...';
ValueList.Cells[0,4]:='...';
ValueList.Cells[0,5]:='...';
ValueList.Cells[0,6]:='...';
ValueList.Cells[0,7]:='...';
ValueList.Cells[0,8]:='...';
ValueList.Cells[0,9]:='...';
ValueList.Cells[0,10]:='...';
ValueList.Cells[1,1]:='0';
ValueList.Cells[1,2]:='0';
ValueList.Cells[1,3]:='0';
ValueList.Cells[1,4]:='0';
ValueList.Cells[1,5]:='0';
ValueList.Cells[1,6]:='0';
ValueList.Cells[1,7]:='0';
ValueList.Cells[1,8]:='0';
ValueList.Cells[1,9]:='0';
ValueList.Cells[1,10]:='0';
end;





procedure Sortiranje(ValueList: TValueListEditor);
var i1,val1,val2,i,greska:integer;   s1,s2:string;
begin
for i:=1 to ValueList.RowCount-1 do
begin
for i1:=ValueList.RowCount-1 downto 2 do
begin
Val(ValueList.Cells[1,i1],val1,greska);
Val(ValueList.Cells[1,i1-1],val2,greska);

if Val2<Val1 then
begin
s1:= ValueList.Cells[0,i1];
s2:= ValueList.Cells[0,i1-1];
ValueList.Cells[0,i1]:=s2;
ValueList.Cells[0,i1-1]:=s1;
ValueList.Cells[2,i1]:=inttostr(Val2);
ValueList.Cells[2,i1-1]:=inttostr(Val1);
end;
end;
end;
end;



procedure Ubacivanje(I1,I2,I3,I4,I5,I6,I7,I8,I9,I10,B1,
B2,B3,B4,B5,B6,B7,B8,B9,B10: TLabel; ValueList: TValueListEditor);
begin
I1.Caption:= ValueList.Cells[0,1];
I2.Caption:= ValueList.Cells[0,2];
I3.Caption:= ValueList.Cells[0,3];
I4.Caption:= ValueList.Cells[0,4];
I5.Caption:= ValueList.Cells[0,5];
I6.Caption:= ValueList.Cells[0,6];
I7.Caption:= ValueList.Cells[0,7];
I8.Caption:= ValueList.Cells[0,8];
I9.Caption:= ValueList.Cells[0,9];
I10.Caption:= ValueList.Cells[0,10];
B1.Caption:= ValueList.Cells[1,1];
B2.Caption:= ValueList.Cells[1,2];
B3.Caption:= ValueList.Cells[1,3];
B4.Caption:= ValueList.Cells[1,4];
B5.Caption:= ValueList.Cells[1,5];
B6.Caption:= ValueList.Cells[1,6];
B7.Caption:= ValueList.Cells[1,7];
B8.Caption:= ValueList.Cells[1,8];
B9.Caption:= ValueList.Cells[1,9];
B10.Caption:= ValueList.Cells[1,10];
end;





procedure TForm1.MenjajTezinu(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

IF NOT pokrenuto THEN
BEGIN

case tezina of

1: shLako.Pen.Color:=clSilver;
2: shSrednje.Pen.Color:=clSilver;
3: shTesko.Pen.Color:=clSilver;
end;

(Sender as TShape).Pen.Color:=clBlack;
(Sender as TShape).Pen.Width:=2;
tezina:= (Sender as TShape).Tag;

case tezina of
1: begin
   lblTezina.Caption:= strTezina + 'Lako';
   shLoptica.Width:=45; shLoptica.Height:=45;
   shLoptica.Top:=-(shLoptica.Height);
   end;
2: begin
   lblTezina.Caption:= strTezina + 'Srednje';
   shLoptica.Width:=35; shLoptica.Height:=35;
   shLoptica.Top:=-(shLoptica.Height);
   end;
3: begin
   lblTezina.Caption:= strTezina + 'Tesko';
   shLoptica.Width:=25; shLoptica.Height:=25;
   shLoptica.Top:=-(shLoptica.Width);
   end;
end;

END;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin

if desno=true then
begin
if  shLoptica.Left+5<=(694-shLoptica.Width) then shLoptica.Left:= shLoptica.Left+5 else shLoptica.Left:=(694-shLoptica.Width);
end
      else
      begin
       if shLoptica.Left-5>=3 then  shLoptica.Left:= shLoptica.Left-5 else shLoptica.Left:=3;
      end;

if dole=true then
begin
if  shLoptica.Top+5<=(507-shLoptica.Width) then shLoptica.Top:= shLoptica.Top+5 else shLoptica.Top:=(507-shLoptica.Width);
end
      else
      begin
       if shLoptica.Top-5>=3 then  shLoptica.Top:= shLoptica.Top-5 else shLoptica.Top:=3;
      end;

if shLoptica.Left>=(694-shLoptica.Width) then desno:=false;
if shLoptica.Top>=(507-shLoptica.Width) then dole:=false;

if shLoptica.Left<=3 then desno:=true;
if shLoptica.Top<=3 then dole:=true;

end;

procedure TForm1.FormCreate(Sender: TObject);
var mix:integer;
begin
Randomize;
mix:= Random(2);

if mix=0 then  desno:=false else desno:=true;
shLoptica.Left:=3+Random(Form1.ClientWidth-2);

dole:=true;
pokrenuto:=false;
pauza:=true;
skor:=0;
tezina:=1;
trenutnoVreme:=0;


TabelaLako.Strings.LoadFromFile('HighScoreLako.ini');
Val(TabelaLako.Cells[col,row],TOPRezultatLako,greska1);
Sortiranje(TabelaLako);

TabelaSrednje.Strings.LoadFromFile('HighScoreSrednje.ini');
Val(TabelaSrednje.Cells[col,row],TOPRezultatSrednje,greska2);
Sortiranje(TabelaSrednje);

TabelaTesko.Strings.LoadFromFile('HighScoreTesko.ini');
Val(TabelaTesko.Cells[col,row],TOPRezultatTesko,greska3);
Sortiranje(TabelaTesko);

col:= TabelaLako.ColCount-1;
row:= TabelaLako.RowCount-1;



shLako.Pen.Color:=clBlack;
cbPoz.Selected:= shArena.Brush.Color;
cbOkvirLoptice.Selected:= shLoptica.Pen.Color;
cbUnutra.Selected:= shLoptica.Brush.Color;
cbOkvirArene.Selected:= shArena.Pen.Color;
shLoptica.Width:=45;
shLoptica.Height:=45;
shLoptica.Top:=-(shLoptica.Height);
lblVreme.Caption:= IntToStr(duzinaIgre);
imeIgraca:= strUnknown;
edIme.Text:= strUnknown;



Screen.Cursors[1]:=LoadCursorFromFile('Meta.ani');
end;

procedure TForm1.shLopticaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if not pauza then
begin
Inc(skor,1);
lblPoeni.Caption:=IntToStr(skor);
end;
end;

procedure TForm1.Shape3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  Perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
if BitBtn1.Caption=strNovaIgra  then BitBtn6.Click
else

begin

if pauza=true then
 begin
 pokrenuto:=true;
 pauza:=false;
 Timer1.Enabled:=true;
 Timer2.Enabled:=true;
 BitBtn1.Caption:= strPauza;
 pokreni.Caption:= strPauza;
 cbOkvirLoptice.Enabled:=false;
 cbUnutra.Enabled:=false;
 cbPoz.Enabled:=false;
 cbOkvirArene.Enabled:=false;
 edIme.Enabled:=false;
 if lblVreme.Caption='30' then lblVreme.Caption:='29';
 end
     else
        begin
        pauza:=true;
        Timer1.Enabled:=false;
        Timer2.Enabled:=false;
        BitBtn1.Caption:= strNastavi;
        pokreni.Caption:= strNastavi;
        end;
    end;
end;


procedure TForm1.cbOkvirLopticeChange(Sender: TObject);
begin
shLoptica.Pen.Color:= cbOkvirLoptice.Selected;
end;

procedure TForm1.cbUnutraChange(Sender: TObject);
begin
shLoptica.Brush.Color:= cbUnutra.Selected;
end;

procedure TForm1.cbPozChange(Sender: TObject);
begin
shArena.Brush.Color:= cbPoz.Selected;
end;

procedure TForm1.cbOkvirAreneChange(Sender: TObject);
begin
shArena.Pen.Color:= cbOkvirArene.Selected;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
pokrenuto:=false;
pauza:=true;
Timer1.Enabled:=false;
Timer2.Enabled:=false;
trenutnoVreme:=0;
skor:=0;
BitBtn1.Caption:=strPokreni;
pokreni.Caption:=strPokreni;
shLoptica.Top:=-(shLoptica.Width);
shLoptica.Left:=3+Random(Form1.ClientWidth-2);
lblPoeni.Caption:='0';
lblVreme.Caption:=IntToStr(duzinaIgre);
edIme.Enabled:=true;

        cbOkvirLoptice.Enabled:=true;
        cbUnutra.Enabled:=true;
        cbPoz.Enabled:=true;
        cbOkvirArene.Enabled:=true;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
trenutnoVreme:=trenutnoVreme+1;
lblVreme.Caption:= IntToStr(duzinaIgre-1-trenutnoVreme);

if trenutnoVreme=29 then
begin
pokrenuto:=false;
pauza:=true;
Timer1.Enabled:=false;
Timer2.Enabled:=false;
BitBtn1.Caption:=strNovaIgra;
pokreni.Caption:=strNovaIgra;

 
case tezina of
1: begin


IF skor>TOPrezultatLako then begin
TabelaLako.InsertRow(imeIgraca,inttostr(skor),false);


Sortiranje(TabelaLako);
TabelaLako.DeleteRow(TabelaLako.RowCount-1);
TabelaLako.Strings.SaveToFile('HighScoreLako.ini');

Ubacivanje(Form2.lblIme1L,Form2.lblIme2L,Form2.lblIme3L,Form2.lblIme4L,Form2.lblIme5L,Form2.lblIme6L,
Form2.lblIme7L,Form2.lblIme8L,Form2.lblIme9L,Form2.lblIme10L,Form2.lblSkor1L,Form2.lblSkor2L,Form2.lblSkor3L,
Form2.lblSkor4L,Form2.lblSkor5L,Form2.lblSkor6L,Form2.lblSkor7L,Form2.lblSkor8L,Form2.lblSkor9L,
Form2.lblSkor10L, TabelaLako);
MessageDlg('estitamo! Dospeli ste na highscore listu!',mtInformation,[mbOk],0);
Form2.PageControl1.ActivePageIndex:=0;
Form2.ShowModal;
end;  end;

2: begin


IF skor>TOPrezultatSrednje then begin
TabelaSrednje.InsertRow(imeIgraca,inttostr(skor),false);


Sortiranje(TabelaSrednje);
TabelaSrednje.DeleteRow(TabelaSrednje.RowCount-1);
TabelaSrednje.Strings.SaveToFile('HighScoreSrednje.ini');

Ubacivanje(Form2.lblIme1S,Form2.lblIme2S,Form2.lblIme3S,Form2.lblIme4S,Form2.lblIme5S,Form2.lblIme6S,
Form2.lblIme7S,Form2.lblIme8S,Form2.lblIme9S,Form2.lblIme10S,Form2.lblSkor1S,Form2.lblSkor2S,Form2.lblSkor3S,
Form2.lblSkor4S,Form2.lblSkor5S,Form2.lblSkor6S,Form2.lblSkor7S,Form2.lblSkor8S,Form2.lblSkor9S,
Form2.lblSkor10S, TabelaSrednje);
MessageDlg('estitamo! Dospeli ste na highscore listu!',mtInformation,[mbOk],0);
Form2.PageControl1.ActivePageIndex:=1;
Form2.ShowModal;
end;  end;


3: begin

IF skor>TOPrezultatTesko then begin
TabelaTesko.InsertRow(imeIgraca,inttostr(skor),false);


Sortiranje(TabelaTesko);
TabelaTesko.DeleteRow(TabelaSrednje.RowCount-1);
TabelaTesko.Strings.SaveToFile('HighScoreTesko.ini');

Ubacivanje(Form2.lblIme1T,Form2.lblIme2T,Form2.lblIme3T,Form2.lblIme4T,Form2.lblIme5T,Form2.lblIme6T,
Form2.lblIme7T,Form2.lblIme8T,Form2.lblIme9T,Form2.lblIme10T,Form2.lblSkor1T,Form2.lblSkor2T,Form2.lblSkor3T,
Form2.lblSkor4T,Form2.lblSkor5T,Form2.lblSkor6T,Form2.lblSkor7T,Form2.lblSkor8T,Form2.lblSkor9T,
Form2.lblSkor10T, TabelaTesko);
MessageDlg('estitamo! Dospeli ste na highscore listu!',mtInformation,[mbOk],0);
Form2.PageControl1.ActivePageIndex:=2;
Form2.ShowModal;
end;  end;


END;

end;


end;

procedure TForm1.edImeChange(Sender: TObject);
begin
imeIgraca:= EdIme.Text;
end;

procedure TForm1.edImeExit(Sender: TObject);
begin
if edIme.Text<>'' then imeIgraca:= EdIme.Text else
begin
imeIgraca:= strUnknown;
edIme.Text:= strUnknown;

end;

end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
Form1.Activate;
Form2.ShowModal;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
Ubacivanje(Form2.lblIme1L,Form2.lblIme2L,Form2.lblIme3L,Form2.lblIme4L,Form2.lblIme5L,Form2.lblIme6L,
Form2.lblIme7L,Form2.lblIme8L,Form2.lblIme9L,Form2.lblIme10L,Form2.lblSkor1L,Form2.lblSkor2L,Form2.lblSkor3L,
Form2.lblSkor4L,Form2.lblSkor5L,Form2.lblSkor6L,Form2.lblSkor7L,Form2.lblSkor8L,Form2.lblSkor9L,
Form2.lblSkor10L, TabelaLako);


Ubacivanje(Form2.lblIme1S,Form2.lblIme2S,Form2.lblIme3S,Form2.lblIme4S,Form2.lblIme5S,Form2.lblIme6S,
Form2.lblIme7S,Form2.lblIme8S,Form2.lblIme9S,Form2.lblIme10S,Form2.lblSkor1S,Form2.lblSkor2S,Form2.lblSkor3S,
Form2.lblSkor4S,Form2.lblSkor5S,Form2.lblSkor6S,Form2.lblSkor7S,Form2.lblSkor8S,Form2.lblSkor9S,
Form2.lblSkor10S, TabelaSrednje);


Ubacivanje(Form2.lblIme1T,Form2.lblIme2T,Form2.lblIme3T,Form2.lblIme4T,Form2.lblIme5T,Form2.lblIme6T,
Form2.lblIme7T,Form2.lblIme8T,Form2.lblIme9T,Form2.lblIme10T,Form2.lblSkor1T,Form2.lblSkor2T,Form2.lblSkor3T,
Form2.lblSkor4T,Form2.lblSkor5T,Form2.lblSkor6T,Form2.lblSkor7T,Form2.lblSkor8T,Form2.lblSkor9T,
Form2.lblSkor10T, TabelaTesko);
end;



procedure TForm1.BitBtn7Click(Sender: TObject);
begin
BitBtn1.Visible:=false;
BitBtn2.Visible:=false;
BitBtn4.Visible:=false;
BitBtn5.Visible:=false;
BitBtn6.Visible:=false;
BitBtn7.Visible:=false;
Shape3.Visible:=false;
Label1.Visible:=false;
Label2.Visible:=false;
Label3.Visible:=false;
Label4.Visible:=false;
Label5.Visible:=false;
Label6.Visible:=false;
Label7.Visible:=false;
Label8.Visible:=false;
lblTezina.Visible:=false;
cbOkvirArene.Visible:=false;
cbOkvirLoptice.Visible:=false;
cbPoz.Visible:=false;
cbUnutra.Visible:=false;
Shape1.Visible:=false;
Shape2.Visible:=false;
lblPoeni.Visible:=false;
lblVreme.Visible:=false;
shLako.Visible:=false;
shSrednje.Visible:=false;
shTesko.Visible:=false;
edIme.Visible:=false;
MiniPrikaz.Checked:= false;
end;

procedure TForm1.shArenaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if pauza then
begin
  ReleaseCapture;
  Perform(WM_SYSCOMMAND, $F012, 0);
end;
end;

procedure TForm1.MiniprikazClick(Sender: TObject);
begin
if Miniprikaz.Checked then BitBtn7.Click
     else
        begin
        Shape3.Visible:=true;
        Label1.Visible:=true;
        Label2.Visible:=true;
        Label3.Visible:=true;
        Label4.Visible:=true;
        Label5.Visible:=true;
        Label6.Visible:=true;
        Label7.Visible:=true;
        Label8.Visible:=true;
        lblTezina.Visible:=true;
        cbOkvirArene.Visible:=true;
        cbOkvirLoptice.Visible:=true;
        cbPoz.Visible:=true;
        cbUnutra.Visible:=true;
        Shape1.Visible:=true;
        Shape2.Visible:=true;
        lblPoeni.Visible:=true;
        lblVreme.Visible:=true;
        shLako.Visible:=true;
        shSrednje.Visible:=true;
        shTesko.Visible:=true;
        edIme.Visible:=true;
        BitBtn1.Visible:=true;
        BitBtn2.Visible:=true;
        BitBtn4.Visible:=true;
        BitBtn5.Visible:=true;
        BitBtn6.Visible:=true;
        BitBtn7.Visible:=true;
        Miniprikaz.Checked:= true;
        end;

end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
Form3.ShowModal;
end;

procedure TForm1.OsveziClick(Sender: TObject);
begin
BitBtn1.Refresh;
BitBtn2.Refresh;
BitBtn4.Refresh;
BitBtn5.Refresh;
BitBtn6.Refresh;
BitBtn7.Refresh;

Shape3.Refresh;
Label1.Refresh;
Label2.Refresh;
Label3.Refresh;
Label4.Refresh;
Label5.Refresh;
Label6.Refresh;
Label7.Refresh;
Label8.Refresh;
lblTezina.Refresh;
cbOkvirArene.Refresh;
cbOkvirLoptice.Refresh;
cbPoz.Refresh;
cbUnutra.Refresh;
Shape1.Refresh;
Shape2.Refresh;
lblPoeni.Refresh;
lblVreme.Refresh;
shLako.Refresh;
shSrednje.Refresh;
shTesko.Refresh;
edIme.Refresh;

end;

end.
